import tkinter as tk
from tkinter.filedialog import askopenfilename, asksaveasfilename
from ttkwidgets.autocomplete import AutocompleteCombobox

filepath = ""

countries = ["print", "False", "await", "else", "import", "pass", "None", "break", "except", "in", "raise", "True", "class", "finally", "is", "return", "and", "continue", "for", "lambda", "try", "as", "def", "from", "nonlocal", "while", "assert", "del", "global", "not", "with", "if", "or", "yield"]

def open_file():
    """Open a file for editing."""
    global filepath
    filepath = askopenfilename(
        filetypes=[("Text Files", "*.txt"), ("All Files", "*.*")]
    )
    if not filepath:
        return
    txt_edit.delete(1.0, tk.END)
    with open(filepath, "r") as input_file:
        text = input_file.read()
        txt_edit.insert(tk.END, text)
    window.title(f"Text Editor Application - {filepath}")

def save_content(cont):
    f = open(filepath, "w")
    f.write(cont)
    f.close()

def ofg():
    global txt_edit
    global txt_auto
    txt_edit.insert(tk.END, txt_auto.get() + '\n')
def save_file():
    """Save the current file as a new file."""
    filepath = asksaveasfilename(
        defaultextension="txt",
        filetypes=[("Text Files", "*.txt"), ("All Files", "*.*")],
    )
    if not filepath:
        return
    with open(filepath, "w") as output_file:
        text = txt_edit.get(1.0, tk.END)
        output_file.write(text)
    window.title(f"Code:Desk - {filepath}")

window = tk.Tk()
window.title("Code:Desk")
window.rowconfigure(0, minsize=800, weight=1)
window.columnconfigure(1, minsize=800, weight=1)

txt_auto = AutocompleteCombobox(window, completevalues=countries)
txt_edit = tk.Text(window, height=300)
fr_buttons = tk.Frame(window, relief=tk.RAISED, bd=2)
btn_open = tk.Button(fr_buttons, text="Open", command=open_file)
btn_save_as = tk.Button(fr_buttons, text="Save As...", command=save_file)
btn_save = tk.Button(fr_buttons, text="Save", command=lambda:save_content(txt_edit.get("1.0",'end-1c')))
btn_senter = tk.Button(window, text="Put", command=ofg)

btn_open.grid(row=0, column=0, sticky="ew", padx=5, pady=5)
btn_save.grid(row=1, column=0, sticky="ew", padx=5, pady=5)
btn_save_as.grid(row=2, column=0, sticky="ew", padx=5, pady=5)

fr_buttons.grid(row=0, column=0, sticky="ns")
txt_auto.grid(row=0, column=1, sticky="new")
txt_edit.grid(row=0, column=1, sticky="sew", pady=25)
btn_senter.grid(row=0, column=1, sticky="ne")

window.mainloop()
